(() => {
  const HEADER_HEIGHT = 125;
  const CLASSNAME = 'rapap-sticky-header';
  const HEADER_EL = document.querySelector('#header');
  const WRAPPER_EL = HEADER_EL.querySelector('#navbarStickyWrapper');
  const SOURCE_EL = document.querySelector(`.${CLASSNAME}`);
  let stickyEl = null;

  document.addEventListener('DOMContentLoaded', function() {
    console.log('sticky-header-lib');
    // document.querySelector('#mainContent').style.minHeight = '200dvh'; // @NOTE: for testing
    stickyEl = createStickyEl();
    initTabQueryParam();
    syncActiveState();
  });

  let scrollTicking = false;
  document.addEventListener('scroll', function(event) {
    if (scrollTicking == false) {
      // Throttle scroll event
      window.requestAnimationFrame(function() { 
        showHideCloneEl();
        scrollTicking = false;
      });
      scrollTicking = true;
    }
  });
  
  function createStickyEl() {
    const cloneEl = SOURCE_EL.cloneNode(true);
    cloneEl.classList.remove(CLASSNAME);
    WRAPPER_EL.appendChild(cloneEl);
    return cloneEl;
  }

  function initTabQueryParam() {
    const tabEls = WRAPPER_EL.querySelectorAll('.tab-query-param');
    rapapInitTabQueryParam(tabEls); // @NOTE: This is gobal functioin from tab-query-param-lib
  }

  function syncActiveState() {
    const activeClassname = 'active';
    const sourceTabBtnEls = SOURCE_EL.querySelectorAll('button[data-bs-toggle="tab"]');
    const cloneTabBtnEls = WRAPPER_EL.querySelectorAll('button[data-bs-toggle="tab"]');
    const tabBtnEls = [...sourceTabBtnEls, ...cloneTabBtnEls];
    tabBtnEls.forEach(tabBtnEl => {
      tabBtnEl.addEventListener('shown.bs.tab', function(event) {
        console.log(event);
        const activeEl = event.target;
        const activeEls = document.querySelectorAll(`#${activeEl.id}`);
        activeEls.forEach(activeEl => {
          if (activeEl.classList.contains(activeClassname) === true) return
          activeEl.classList.add(activeClassname);
        });
        const prevActiveEl = event.relatedTarget;
        const prevActiveEls = document.querySelectorAll(`#${prevActiveEl.id}`);
        prevActiveEls.forEach(prevActiveEl => {
          if (prevActiveEl.classList.contains(activeClassname) === false) return
          prevActiveEl.classList.remove(activeClassname);
        })
      });
    })
  }

  function showHideCloneEl() {
    console.log('showHideCloneEl');
    const activeClass = 'rapap-is-sticky';
    const bBox = SOURCE_EL.getBoundingClientRect();
    if (bBox.top < HEADER_HEIGHT) {
      SOURCE_EL.classList.add('invisible');
      HEADER_EL.classList.add(activeClass);
      return;
    }
    SOURCE_EL.classList.remove('invisible');
    HEADER_EL.classList.remove(activeClass);
  }
})();
